/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package interfaz.proyecto;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import java.awt.event.*;
import java.awt.Shape;
import javax.swing.*;

//librerías necesarias para la lectura y escritura de ficheros
import java.io.*;

//Librerías necesarias para la utilización del puerto de comunicaciones

import giovynet.nativelink.SerialPort;
import giovynet.permissions.Info;
import giovynet.serial.Baud;
import giovynet.serial.Com;
import giovynet.serial.Parameters;
import java.util.List;
import javafx.scene.paint.Color;

/**
 *
 * @author Toño
 */


public class InterfazProyecto {
    
    public class Data 
    {
        public String datoRecibido;
        int valorNum[]= new int[16]; //creamos una matriz que contendrá el valor numérico de los sensores.

    }
    
        
    public static void main (String[] arg) throws Exception{
        
        //codigo para mostrar la ventana principal
        
        VentanaPrincipal ventana = new VentanaPrincipal();
        ventana.setTitle("Plantar Preassure");
        ventana.setVisible(true);
        Data data = new InterfazProyecto().new Data();



//código para la comunicación serial      
        
        showsInfoAboutGiovynetDriver();// Shows Information about Giovynet Driver
        SerialPort serialPort = new SerialPort();
        List<String> lstFreeSerialPort = serialPort.getFreeSerialPort();//Gets a list of serial ports free
               
        if(lstFreeSerialPort.size()>0){//if there are free ports
            System.out.println(""+lstFreeSerialPort);
            System.out.println(""+lstFreeSerialPort.get(1)); 
            ventana.jLabel5.setForeground(java.awt.Color.green);
            ventana.jLabel5.setText("Sí");
            Parameters parameters = new Parameters();//Create a parameter object
            parameters.setPort(lstFreeSerialPort.get(1));//assigns the first port found
            parameters.setBaudRate(Baud._460800);//assigns baud rate
            parameters.setByteSize("8");// assigns byte size
            parameters.setParity("N");// assigns parity
            Com com  = new  Com(parameters);// With the "parameters" creates a "Com"
            
            do  {
                
            switch (interfaz.proyecto.VentanaPrincipal.presionadoBoton)
            {
                case 1:
            //Comieenza la adquisición de datos
            //********************************************************************
               
                //Para dotar sincronía, recibimos una cadena que siempre marcará el inicio de la transmisión.
                //Esta cadena serán 4 nueves, creamos una variable para facilitarnos la tarea de hallar el inicio de la cadena de 4 nueves. 
                for (int  i = 0; i < 5000; i++){
                int j=0;
                int indice=0;
                int nueves=0;
                Thread.sleep(13);
                
                data.datoRecibido=com.receiveToString(190);
                
                System.out.println(data.datoRecibido);
                System.out.println(i);
                
                //Buscamos en la cadena los 4 nueves de inicio de cadena.
                
                do{ //Bucle para buscar dentro de la cadena los 4 nueves.
                    j++;
                    if(data.datoRecibido.charAt(j)=='9')
                        if(data.datoRecibido.charAt(j+1)=='9')
                            if(data.datoRecibido.charAt(j+2)=='9')
                                if(data.datoRecibido.charAt(j+3)=='9'){
                                    nueves=1;
                                    indice=j;
                                    j=170;                                    
                                }
                } while (j<170);
                
                if (nueves>0) 
                {
                    System.out.println("indice es "+indice);
                }
                else System.out.println("No se encontraron los caracteres de inicio de cadena.");
                
                
                    
                System.out.println("Valor sensor 1 =" + data.datoRecibido.substring(indice+6,indice+10));
                data.valorNum[0]=Integer.parseInt(data.datoRecibido.substring(indice+6,indice+10));
                System.out.println("Valor sensor 2 =" + data.datoRecibido.substring(indice+11, indice+15));
                data.valorNum[1]=Integer.parseInt(data.datoRecibido.substring(indice+11, indice+15));
                System.out.println("Valor sensor 3 =" + data.datoRecibido.substring(indice+16, indice+20));
                data.valorNum[2]=Integer.parseInt(data.datoRecibido.substring(indice+16, indice+20));
                System.out.println("Valor sensor 4 =" + data.datoRecibido.substring(indice+21, indice +25));
                data.valorNum[3]=Integer.parseInt(data.datoRecibido.substring(indice+21, indice +25));
                System.out.println("Valor sensor 5 =" + data.datoRecibido.substring(indice+28, indice+32));
                data.valorNum[4]=Integer.parseInt(data.datoRecibido.substring(indice+28, indice+32));
                System.out.println("Valor sensor 6 =" + data.datoRecibido.substring(indice+33, indice+37));
                data.valorNum[5]=Integer.parseInt(data.datoRecibido.substring(indice+33, indice+37));
                System.out.println("Valor sensor 7 =" + data.datoRecibido.substring(indice+38, indice+42));
                data.valorNum[6]=Integer.parseInt(data.datoRecibido.substring(indice+38, indice+42));
                System.out.println("Valor sensor 8 =" + data.datoRecibido.substring(indice+43, indice+47));
                data.valorNum[7]=Integer.parseInt(data.datoRecibido.substring(indice+43, indice+47));
                System.out.println("Valor sensor 9 =" + data.datoRecibido.substring(indice+50, indice+54));
                data.valorNum[8]=Integer.parseInt(data.datoRecibido.substring(indice+50, indice+54));
                System.out.println("Valor sensor 10 =" + data.datoRecibido.substring(indice+55, indice+59));
                data.valorNum[9]=Integer.parseInt(data.datoRecibido.substring(indice+55, indice+59));
                System.out.println("Valor sensor 11 =" + data.datoRecibido.substring(indice+60, indice+64));
                data.valorNum[10]=Integer.parseInt(data.datoRecibido.substring(indice+60, indice+64));
                System.out.println("Valor sensor 12 =" + data.datoRecibido.substring(indice+65, indice+69));
                data.valorNum[11]=Integer.parseInt(data.datoRecibido.substring(indice+65, indice+69));
                System.out.println("Valor sensor 13 =" + data.datoRecibido.substring(indice+72, indice+76));
                data.valorNum[12]=Integer.parseInt(data.datoRecibido.substring(indice+72, indice+76));
                //System.out.println("Valor sensor 14 =" + data.datoRecibido.substring(168, 173));
                //System.out.println("Valor sensor 15 =" + data.datoRecibido.substring(180, 185));
                //System.out.println("Valor sensor 16 =" + data.datoRecibido.substring(192, 197)); 
                /*valorNum[0]=Integer.parseInt(data.datoRecibido.substring(1,4));
                System.out.println("weoweo "+valorNum[0]);
                */
               
            //************************************************************
            //Instrucciones para la muestra de los datos obtenidos
            //************************************************************
             int ganancia =20 ;   
                if (interfaz.proyecto.VentanaPrincipal.presionadoBotonG==1)
                    ganancia = 20;
                else if (interfaz.proyecto.VentanaPrincipal.presionadoBotonG==2)
                    ganancia = 10;
                else if (interfaz.proyecto.VentanaPrincipal.presionadoBotonG==3)
                    ganancia = 5;
                    
            // ********************Sensor 1************************
                int k=0;
                
                for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel9.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800)
                   ventana.jPanel9.setBackground(ventana.Colores[31]);
           }

            // ********************Sensor 2************************
            k=1;
                
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel5.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800)
                   ventana.jPanel5.setBackground(ventana.Colores[31]);
           }

            // ********************Sensor 3************************
            k=2;
                
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel3.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800)
                   ventana.jPanel3.setBackground(ventana.Colores[31]);
           }
           
            //***************** Sensor 4**********************
            k=3;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel13.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800)
                   ventana.jPanel13.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 5**********************
            k=4;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel14.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel14.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 6**********************
            k=5;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel2.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel2.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 7**********************
            k=6;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel10.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel10.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 8**********************
            k=7;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel2.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel2.setBackground(ventana.Colores[31]);
           }
            //***************** Sensor 9**********************
            k=8;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel8.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel8.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 10**********************
            k=9;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel22.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel22.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 11**********************
            k=10;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel15.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel15.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 12**********************
            k=11;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel15.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel15.setBackground(ventana.Colores[31]);
           }
            
           //Abrimos el fichero seleccionado y escribimos sobre él los valores de los sensores, si se ha presionado
                //el  botón de iniciar toma de datos. 
                    
                    FileWriter fichero = null;
                    PrintWriter pw = null;
                    Object paciente= ventana.jComboBox1.getSelectedItem();
                    
                    System.out.println(paciente);
                    try
                    {
                        fichero = new FileWriter("c:\\Pacientes\\"+paciente, true);
                        fichero.write(data.datoRecibido.substring(indice,indice+77)+"\r\n");
                       // pw = new PrintWriter(fichero);
                         //pw.write(impFichero,70*i,70);
                         
 
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                    try {
                     // Nuevamente aprovechamos el finally para 
                    // asegurarnos que se cierra el fichero.
                    if (null != fichero)
                         fichero.close();
                    } catch (Exception e2) {
                        e2.printStackTrace();
                    }
                    }
                    if(interfaz.proyecto.VentanaPrincipal.presionadoBoton!=1) i=5000;
                }
                    break;
                    
                case 2:
                    
                    ventana.jPanel9.setBackground(ventana.Colores[0]);
                    ventana.jPanel8.setBackground(ventana.Colores[0]);
                    ventana.jPanel5.setBackground(ventana.Colores[0]);
                    ventana.jPanel2.setBackground(ventana.Colores[0]);
                    ventana.jPanel3.setBackground(ventana.Colores[0]);
                    ventana.jPanel13.setBackground(ventana.Colores[0]);
                    ventana.jPanel14.setBackground(ventana.Colores[0]);
                    ventana.jPanel12.setBackground(ventana.Colores[0]);
                    ventana.jPanel15.setBackground(ventana.Colores[0]);
                    ventana.jPanel22.setBackground(ventana.Colores[0]);
                    ventana.jPanel21.setBackground(ventana.Colores[0]);
                    ventana.jPanel10.setBackground(ventana.Colores[0]);
                    //ventana.jPanel15.setBackground(ventana.Colores[0]);
                    break;
                    
                case 3: 
                    
                    Object paciente= ventana.jComboBox1.getSelectedItem();
                    String texto;
                    try
                    {
                        //Creamos un archivo FileReader que obtiene lo que tenga el archivo
                        FileReader lector=new FileReader("c:\\Pacientes\\"+paciente);

                        //El contenido de lector se guarda en un BufferedReader
                        BufferedReader contenido=new BufferedReader(lector);

                        //Con el siguiente ciclo extraemos todo el contenido del objeto "contenido" y lo mostramos
                    while(interfaz.proyecto.VentanaPrincipal.presionadoBoton==3)
                    {
                        
                        texto=contenido.readLine();
                        texto=contenido.readLine();
                data.valorNum[0]=Integer.parseInt(texto.substring(1,4));
                data.valorNum[1]=Integer.parseInt(texto.substring(6,9));
                data.valorNum[2]=Integer.parseInt(texto.substring(11,14));
                data.valorNum[3]=Integer.parseInt(texto.substring(16,19));
                texto=contenido.readLine();
                data.valorNum[4]=Integer.parseInt(texto.substring(1,4));
                data.valorNum[5]=Integer.parseInt(texto.substring(6,9));
                data.valorNum[6]=Integer.parseInt(texto.substring(11,14));
                data.valorNum[7]=Integer.parseInt(texto.substring(16,19));
                texto=contenido.readLine();
                data.valorNum[8]=Integer.parseInt(texto.substring(1,4));
                data.valorNum[9]=Integer.parseInt(texto.substring(6,9));
                data.valorNum[10]=Integer.parseInt(texto.substring(11,14));
                data.valorNum[11]=Integer.parseInt(texto.substring(16,19));
                texto=contenido.readLine();
                data.valorNum[12]=Integer.parseInt(texto.substring(1,4));
                
                                               
            //************************************************************
            //Instrucciones para la muestra de los datos obtenidos
            //************************************************************
            int ganancia =20 ;   
                if (interfaz.proyecto.VentanaPrincipal.presionadoBotonG==1)
                    ganancia = 20;
                else if (interfaz.proyecto.VentanaPrincipal.presionadoBotonG==2)
                    ganancia = 10;
                else if (interfaz.proyecto.VentanaPrincipal.presionadoBotonG==3)
                    ganancia = 5;
            // ********************Sensor 1************************
                int k=0;
                for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel9.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800)
                   ventana.jPanel9.setBackground(ventana.Colores[31]);
           }

            // ********************Sensor 2************************
            k=1;
                
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel5.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800)
                   ventana.jPanel5.setBackground(ventana.Colores[31]);
           }

            // ********************Sensor 3************************
            k=2;
                
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel3.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800)
                   ventana.jPanel3.setBackground(ventana.Colores[31]);
           }
           
            //***************** Sensor 4**********************
            k=3;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel13.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800)
                   ventana.jPanel13.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 5**********************
            k=4;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel14.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel14.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 6**********************
            k=5;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel2.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel2.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 7**********************
            k=6;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel10.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel10.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 8**********************
            k=7;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel2.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel2.setBackground(ventana.Colores[31]);
           }
            //***************** Sensor 9**********************
            k=8;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel8.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel8.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 10**********************
            k=9;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel22.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel22.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 11**********************
            k=10;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel15.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel15.setBackground(ventana.Colores[31]);
           }
            
            //***************** Sensor 12**********************
            k=11;
            for(int ite=0;ite<31;ite++)
           {
               if(data.valorNum[k]>ite*ganancia && data.valorNum[k]<(ite+1)*ganancia)
                   ventana.jPanel15.setBackground(ventana.Colores[ite]);
               if(data.valorNum[k]>800) ventana.jPanel15.setBackground(ventana.Colores[31]);
           }
                    Thread.sleep(13*interfaz.proyecto.VentanaPrincipal.velocidad);
                    }
                                        
                    }
                    

                         //Si se causa un error al leer cae aqui
                    catch(Exception e)
                    {
                        System.out.println("Error al leer");
                        VentanaError error = new VentanaError();
                        error.setTitle("FIN");
                        error.jLabel1.setText("Se finalizó la lectura del fichero                                       ");
                        error.jLabel2.setText("");
                        error.setVisible(true);
                        interfaz.proyecto.VentanaPrincipal.presionadoBoton=2;
                    }
                    
                    
                    break;
           
                
            }
    }while (true);
    
            
           // System.out.println("-- End of transmission--");
            
        }else{
            System.out.println("There is no free serial ports.");
            ventana.jLabel5.setForeground(java.awt.Color.red);
            ventana.jLabel5.setText("No");
        } 
        

        
   }
    
            
    /**
     * @param args the command line arguments
     */
   
       public static void showsInfoAboutGiovynetDriver(){
       System.out.println("------------------------------------------------------------------------------->");
       System.out.println("Giovynet Driver version "+Info.getVersion());
       System.out.println("Type of distribution: "+Info.getTypeOfDistribution());
       System.out.println("Number of devices allowed: "+Info.getNumDevicesAllowed());
       System.out.println("Distribution permissions: "+Info.getDistributionLicense());
       System.out.println("<-------------------------------------------------------------------------------");
    } 
       

    
}
